#ifndef __UCAM_H__
#define __UCAM_H__
#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif
 
// Define colours
#define GREY_2BIT 0x01
#define GREY_4BIT 0x02
#define GREY_8BIT 0x03
#define COLOUR_8BIT 0x04
#define COLOUR_12BIT 0x05
#define COLOUR_16BIT 0x06
#define JPEG 0x07
// Define RAW formats
#define RAW_80x60 0x01
#define RAW_160x120 0x03
#define RAW_320x240 0x05
#define RAW_640x480 0x07
#define RAW_128x128 0x09
#define RAW_128x96 0x0B
// Define JPEG formats
#define JPEG_60x64 0x01
#define JPEG_160x128 0x03
#define JPEG_320x240 0x05
#define JPEG_640x480 0x07
// Define uCam responses
#define _ACK 0x0E
#define _SYNC 0x0D
 
// mode codes for 23K256
#define BYTE_MODE       0x00
#define SEQUENTIAL_MODE 0x40
 
// command codes for 23K256
#define READ            0x03
#define WRITE           0x02
#define READ_STATUS     0x05 // called RDSR in datasheet
#define WRITE_STATUS    0x01 // called WRSR in datasheet
 
 
class uCam 
{
public:
   
	HardwareSerial *_uCam_Serial; // le port serie ou est branchée la camera
    unsigned long _baud;
    // constructor
    uCam(HardwareSerial *camPort,unsigned long baud); // précise le port série appel ex : uCam(&Serial2,115200)

    // Methods
	void begin(); // initialise la communication
    boolean Sync(); // synchronise la camera
    boolean SetBaud(int baud);
    boolean Initial(byte COLOUR, byte RES); // specifie le format de l'image à renvoyer
    boolean Get_Picture(byte *data);
    boolean Get_Response(byte type, byte command); 
    
    
private:
   
};
 
#endif